
clc
clear


step=100;             %mm step
radius=980;          %outer radius to stay whitin
iradius=250;           %inner radius to stay whithout

margin=1000-radius     %margin we have to concider to stay whithin the 
                       %reflecting surface. Plus the 25 mm from the edge.

a=(floor(radius/step))+1;

t=13;                
%seconds needed to wait for the laser to stabilize
p=0.5;                %seconds needed between taking a picture
                    %(turning on and off "cooling")
f=3000;               %Feedrate in mm/min
                    
                    
for R=1:a
    for C=1:a
        A(R,C)=sqrt(((R-1)*step)^2+((C-1)*step)^2);
    end
       
end

%A                %to check if the coordinates are whithin set boundaries

D= A < radius;
E= A >= iradius;
logical= E.*D;
logical1=logical>0;

filename='gcodes.txt';
fid=fopen(filename,'w');

oddrow=1:2:a;
evenrow=2:2:a;

ODD=int2str(oddrow);
EVEN=int2str(evenrow);

gridcount=0;

oddcount=0;
evencount=0;
count=0;

for r=2:a;
    
    if rem(r, 2) == 0
            for c=a:-1:1;
                if logical1(r,c)==1;
                %produce  G-codes
                B=zeros(5,7);
                G=num2cell(B);
                Z=A(1,c);
                X=Z-radius;
                Q=A(r,1);
                Y=Q*(-1);
                
                G{1,1}='G01';
                G{1,2}='F';
                G{1,3}=f;
                G{1,4}='X';
                G{1,5}=X;
                
                G{1,6}='Y';
                G{1,7}=Y;
                
                G{2,1}='G04';
                G{2,2}='P';
                G{2,3}=t;
                G{2,4}=' ';
                G{2,5}=' ';
                G{2,6}=' ';
                G{2,7}=' ';
                
                G{3,1}='M07';
                G{3,2}=' ';
                G{3,3}=' ';
                G{3,4}=' ';
                G{3,5}=' ';
                G{3,6}=' ';
                G{3,7}=' ';
                
                G{4,1}='G04';
                G{4,2}='P';
                G{4,3}=p;
                G{4,4}=' ';
                G{4,5}=' ';
                G{4,6}=' ';
                G{4,7}=' ';
                
                G{5,1}='M09';
                G{5,2}=' ';
                G{5,3}=' ';
                G{5,4}=' ';
                G{5,5}=' ';
                G{5,6}=' ';
                G{5,7}=' ';
                
                G;
                
                fprintf(fid, '%s %s %d %s %d %s %d\r\n', G{1,:});
                fprintf(fid, '%s %s %.1f %s %s %s %s\r\n', G{2,:});
                fprintf(fid, '%s %s %s %s %s %s %s\r\n', G{3,:});
                fprintf(fid, '%s %s %.1f %s %s %s %s\r\n', G{4,:});
                fprintf(fid, '%s %s %s %s %s %s %s\r\n', G{5,:});
                
                gridcount=gridcount+1;
                else
                    evencount=evencount +1;
                end
            end
            
    elseif rem(r,2)~=0;
            for c=1:a;
                if logical1(r,c)==1;
                %produce G-codes:
                B=zeros(5,7);
                G=num2cell(B);
                Z=A(1,c);
                X=Z-radius;
                Q=A(r,1);
                Y=Q*(-1);
                
                G{1,1}='G01';
                G{1,2}='F';
                G{1,3}=f;
                G{1,4}='X';
                G{1,5}=X;
                G{1,6}='Y';
                G{1,7}=Y;
                
                G{2,1}='G04';
                G{2,2}='P';
                G{2,3}=t;
                G{2,4}=' ';
                G{2,5}=' ';
                G{2,6}=' ';
                G{2,7}=' ';
                
                G{3,1}='M07';
                G{3,2}=' ';
                G{3,3}=' ';
                G{3,4}=' ';
                G{3,5}=' ';
                G{3,6}=' ';
                G{3,7}=' ';
                
                G{4,1}='G04';
                G{4,2}='P';
                G{4,3}=p;
                G{4,4}=' ';
                G{4,5}=' ';
                G{4,6}=' ';
                G{4,7}=' ';
                
                G{5,1}='M09';
                G{5,2}=' ';
                G{5,3}=' ';
                G{5,4}=' ';
                G{5,5}=' ';
                G{5,6}=' ';
                G{5,7}=' ';
                
                G;
                
                fprintf(fid, '%s %s %d %s %d %s %d\r\n', G{1,:});
                fprintf(fid, '%s %s %.1f %s %s %s %s\r\n', G{2,:});
                fprintf(fid, '%s %s %s %s %s %s %s\r\n', G{3,:});
                fprintf(fid, '%s %s %.1f %s %s %s %s\r\n', G{4,:});
                fprintf(fid, '%s %s %s %s %s %s %s\r\n', G{5,:});
                
                gridcount=gridcount+1;
                else
                    oddcount=oddcount+1;
                end
            end
    else 
        count = count + 1;
    end
end

logical1;
gridcount
oddcount
evencount
count

fclose(fid);
