%% Image registration
% To allign the images from each image aquisition set, an image
% registration has to be done.

clc
clear

FirstNumber = 1;
LastNumber = 3;

%% Calculate metric and optimization values before loop

cd('C:\Users\victos\Pictures\dist685leveled\N-E registered');

Fixed=imread('fixed.jpg');
Fixed=Fixed(:,:,1);
Moving = imread('moving.jpg');
Moving = Moving(:,:,1);

[optimizer,metric] = imregconfig('monomodal');

%% Loop images
%matlabpool open 4

tic
parfor i = 1:LastNumber - FirstNumber + 1
    cd('C:\Users\victos\Pictures\dist685leveled\N-E registered');
    Moving = imread(strcat('Reg_', num2str(i+),'.jpg'));


%% Convert to grayscal image with red color data
Moving=Moving(:,:,1);

%% view the two images
%imshow(Moving)
%imtool(Fixed)

%% view the images side by side in a montage
%imshowpair(Fixed,Moving,'montage');

%% Configure parameters in imregconfig
%[optimizer,metric] = imregconfig('monomodal');

%% Default registration 
registered = imregister(Moving,Fixed,'translation',optimizer,metric);
%figure;
%imshowpair(registered,Fixed);
%title('Default registration');

%% Change visualisation in imshowpair
%figure;
%imshowpair(registered,Fixed,'diff');

%%
cd('C:\Users\victos\Pictures\dist685leveled\N-E registered');

Filename = strcat('Reg_',num2str(i),'.jpg');
imwrite(registered,Filename);
end
time = toc
%matlabpool close 4
    